%Integration based on the simpson rule

function [S_w_tot] = Uni_spec(w, n, d, min, max, epsi_1O,epsi_1E, epsi_2O, epsi_2E)                                            
            
c0=2.99792458e+8;
dkx = (max-min)/n;                                         
kx = zeros(n+1,1);        %horizontal component of wavevector k
s_wkx = zeros(n+1,1);
k0=w/c0;
for ind=1:n+1
    kx(ind)= min+(ind-1)*dkx;
  %  vertical component of wavevector k
    kz1O= sqrt(epsi_1O*k0^2-kx(ind)^2); 
    kz2O= sqrt(epsi_2O*k0^2-kx(ind)^2); 
    kz1E=sqrt(epsi_1O*k0^2-kx(ind)^2*epsi_1O/epsi_1E);
    kz2E=sqrt(epsi_2O*k0^2-kx(ind)^2*epsi_2O/epsi_2E);
    if (imag(kz1O)<0)
        kz1O=-kz1O;
    end
    if (imag(kz2O)<0)
        kz2O=-kz2O;
    end
    if (imag(kz1E)<0)
        kz1E=-kz1E;
    end
    if (imag(kz2E)<0)
        kz2E=-kz2E;
    end
    %for vacuum
   	kz3 = sqrt(k0^2-kx(ind)^2);    %vacuum gap 
    
  %  frensnel coefficients
   	rs31 = (kz3-kz1O)/(kz3+kz1O);                 %s-polarization interface between 1 and 3
   	rp31 = (epsi_1O*kz3-kz1E)/(epsi_1O*kz3+kz1E);        %p-polarization interface between 1 and 3
    rs32 = (kz3-kz2O)/(kz3+kz2O);                  %s-polarization interface between 2 and 3
   	rp32 = (epsi_2O*kz3-kz2E)/(epsi_2O*kz3+kz2E);       %p-polarization interface between 2 and 3
  %  s function 
    tps_temp = abs(1-rs31*rs32*exp(2*i*kz3*d));
   	tpp_temp = abs(1-rp31*rp32*exp(2*i*kz3*d));
    e_temp = exp(-2*imag(kz3)*d);
    if(kx(ind)<k0)
        trans = (1-abs(rs31)^2)*(1-abs(rs32)^2)/tps_temp^2+(1-abs(rp31)^2)*(1-abs(rp32)^2)/(tpp_temp^2);
        s_wkx(ind) = kx(ind)*trans/(4*pi*pi);
    else
        trans = 4*e_temp*imag(rs31)*imag(rs32)/(abs(1-rs31*rs32*e_temp))^2+4*e_temp*imag(rp31)*imag(rp32)/(abs(1-rp31*rp32*e_temp))^2;
        s_wkx(ind) = kx(ind)*trans/(4*pi*pi);
    end
end  
    S_w_tot=(s_wkx(1)+4*sum(s_wkx(2:2:n))+2*sum(s_wkx(3:2:n-1))+s_wkx(n+1))*dkx/3;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Note added: trans is the transmission coefficient
%It can be viewed as the tramsmittance for propagating waves or tunneling coefficient for evanescent waves
%s_wkx is the transmission coefficient multiplied by kx and divided by 4*pi^2
%S_w_tot is the transmission coefficient*kx/(4*pi*pi) integrated over kx from min to max

                
                
                
                
                